$(document).ready(function () {

    var address_input_name = '';
	var prefix = '';

    if (document.getElementsByName("address").length == 1)
        address_input_name = 'address';
    else if (document.getElementsByName("address1").length == 1)
        address_input_name = 'address1';
    else if (document.getElementsByName("delivery_address").length == 1)
	{
		prefix = 'delivery_';
        address_input_name = prefix + 'address';
	}
    else if (document.getElementsByName("delivery_address1").length == 1)
	{
        prefix = 'delivery_';
        address_input_name = prefix + 'address1';
	}
    else
        address_input_name = 'address2';

    var address_field = $( "input[name='"+address_input_name+"']" );


    if (typeof elp_postapi_integration_promo_text !== 'undefined') {
        $('.postapi_txt').remove();
        $("input[name*='" + prefix + "postcode']").after(elp_postapi_integration_promo_text);
    }


    if(
        address_field.length === 1 &&
        typeof address_field.autocomplete === 'function' &&
        typeof elp_postapi_integration_autocomplete !== 'undefined' &&
        elp_postapi_integration_autocomplete == 1
    )
    {
        var request_args = [];

        if (typeof elp_postapi_integration_key !== 'undefined')
            request_args['key'] = elp_postapi_integration_key;
        else
        if (typeof elp_postapi_integration_token !== 'undefined')
            request_args['token'] = elp_postapi_integration_token;
        else
            request_args['key'] = '';



        address_field.autocomplete(elp_postapi_integration_url, {
            minChars: 4,
            delay: 400,
            multiple: false,
            autoFill: false,
            selectFirst: false,
            scroll: false,
            dataType: 'json',
            extraParams: {
                token: request_args['token'],
                key: request_args['key'],
                autocomplete: 1,
                wide_number: 0,
            },
            formatItem: function(data, i, max, value, term) {
                return value;
            },
            parse: function(resp) {
                var r = [];
                if (!resp.success)
                {
                    return r;
                }

                for(var i = 0, l = resp.data.length; i < l; i++)
                {
                    var t = '';
                    var address = resp.data[i].address;

                    if (address === '')
                    {
                        t = (resp.data[i].city);
                    }
                    else
                    {
                        if(typeof resp.address_apartment != "undefined")
                        {
                            address += '-'+resp.address_apartment;
                        }

                        t = (address + ', ' + resp.data[i].city);
                    }

                    r.push({
                        data: {
                            label: t,
                            value: address,
                            address: address,
                            city: resp.data[i].city,
                            postcode: resp.data[i].postcode
                        },
                        value: t + ', ' + resp.data[i].postcode,
                        result: address
                    });
                }

                return r;
            }
        })
            .result(function(event, data, formatted) {
                $("input[name='" + prefix + "postcode']").val(data.postcode);
                $("input[name='" + prefix + "city']").val(data.city);
                $(address_field).val(data.address);
                $( "input[name='" + prefix + "postcode']" ).trigger('change'); // change for validation
                $( "input[name='" + prefix + "city']" ).trigger('change'); // change for validation
            });

        address_field.attr('autocomplete', 'nofill');
    }
    else
    {
        $(document).on( "blur", "input[name='"+address_input_name+"']", function(){ searchPostCode(); } );
        $(document).on( "blur", "input[name='" + prefix + "city']", function(){ searchPostCode(); } );
    }


    function searchPostCode()
    {
        if (
			typeof elp_postapi_integration_lt_country_id !== 'undefined' &&
			$("[name=id_country]").first().val() != elp_postapi_integration_lt_country_id
		) {
			return;
		}

        var address = $( "input[name='"+address_input_name+"']" ).val();
        var city = $( "input[name='" + prefix + "city']" ).val();

        var request_data = {address: address, city: city};

        if (typeof elp_postapi_integration_key !== 'undefined')
            request_data['key'] = elp_postapi_integration_key;
        else
        if (typeof elp_postapi_integration_token !== 'undefined')
            request_data['token'] = elp_postapi_integration_token;
        else
            request_data['key'] = '';


        if (address.length > 0 && city.length > 0)
        {
            $.ajax({
                method: "POST",
                url: (typeof elp_postapi_integration_url !== 'undefined' ? elp_postapi_integration_url : ''),
                dataType: 'json',
                data: request_data,
                crossDomain: true,
                timeout: 10000,
                success: function(data) {


                    if (data.success == true && data.total_found == 1)
                    {
                        $( "input[name='" + prefix + "postcode']" ).val(data.data[0].postcode);
                        $( "input[name='" + prefix + "postcode']" ).trigger('change');
                    }
                }
            });
            return;
        }
    }

});
